ClearAll[UHDinit,UHDdeinit,UHDopenDefaultDevice,UHDstaticTxEnabledQ,
	UHDenableStaticTx,UHDdisableStaticTx,UHDtxEnabledQ,UHDenableTx,UHDdisableTx,
	UHDstartDefaultStreamer,UHDstopDefaultStreamer,UHDgetMainboardOfTxChannel,
	UHDgetAllTxChannels,UHDgetTxMasterChannel,
	UHDgenerateIQoffsetFrequencyWaveform,
	UHDgenerateAndQueueMinimalIQoffsetFrequencyWaveform,
	UHDgetStreamedTxChannels,UHDgetStaticallyEnabledTxChannels,
	UHDgetEnabledTxChannels,UHDcheckMIMOstate,UHDgetChannelSpecificSetting,
	UHDodmrCW,$UHDtxStreamer,$UHDdefaultTxFrequency,$UHDdefaultTxPower,
	$UHDtxFrequencyOffset,$UHDtxPowerOffset,$UHDtxPhase,$UHDtxAmplitude,
	$UHDuseStaticTxForZeroFrequencyOffset,$UHDtreatTxFrequencyWithOffset,
	$UHDscaleTxAmplitudeForFinePowerControl,$UHDtxListModeLists,
	$UHDtxListModeFrequencyList,$UHDtxListModePowerList,
	$UHDtxListModeSelectedList,$UHDtxListModeStepQ,$UHDtxListModeTriggerSingle,
	$UHDtxListModeDwellTime,$UHDtxListModeIncludeSettingInDwellTime,
	$UHDtxListModeTriggerTimeout,$UHDtxListModeBlankerTime,
	$UHDtxListModeBlankerGPIOspec,$UHDtxListModeThreads,$UHDdefaultTxChannel,
	$UHDcontrollProcess,$UHDlink,$UHDusrp,$UHDdebugPrint,$UHDdebug,
	FunctionQ,SymbolQ];
FunctionQ[x_]:=MemberQ[{Symbol,Function},Head[x]];
SymbolQ[x_]:=Head[x]===Symbol;
$UHDdefaultTxChannel[_]=0;
$UHDuseStaticTxForZeroFrequencyOffset[_]=False;
$UHDtreatTxFrequencyWithOffset[_]=False;
$UHDscaleTxAmplitudeForFinePowerControl[_]=True;
$UHDtxListModeBlankerGPIOspec[_]={0,"FP0",1,0};
$UHDtxListModeBlankerTime[_]=0;
$UHDtxListModePowerApmlifierNameList[_]={};
$UHDtxListModeSetOnlyFrequencyOfMasterChannel[_]=True;
$UHDdebug=False;
$UHDdebugPrint[msg___]:=If[$UHDdebug===True,Print[msg]];
UHDresetStatusVariables[dev_]:=(
	$UHDdefaultTxFrequency[dev]=1*^8;
	$UHDdefaultTxPower[dev]=-30;
	$UHDtxFrequencyOffset[dev]=0;
	$UHDtxPowerOffset[dev]=71.4;
	$UHDtxPhase[dev]=0;
	$UHDtxAmplitude[dev]=1;
	If[dev=!=_&&!ListQ[$UHDtxListModeLists[dev]],
		$UHDtxListModeLists[dev]={}];
	$UHDtxListModeFrequencyList[dev]={};
	$UHDtxListModePowerList[dev]={};
	$UHDtxListModeSelectedList[dev]="";
	$UHDtxListModeStepQ[dev]=False;
	$UHDtxListModeTriggerSingle[dev]=True;
	$UHDtxListModeDwellTime[dev]=0.15;
	$UHDtxListModeIncludeSettingInDwellTime[dev]=True);
UHDresetStatusVariables[_];
Options[UHDgetChannelSpecificSetting]={ListExpander->
		Function[{channels,setting},
			PadRight[#,Length[channels],#]&@If[ListQ[#],#,{#}]&@setting]};
UHDgetChannelSpecificSetting[dev_Integer,channel:All|{___Integer}|_Integer,
		setting_,OptionsPattern[]]:=
	If[FunctionQ[setting],
		If[ListQ[#],If[channel===All,#,#[[1+channel]]],
				If[ListQ[channel],ConstantArray[#,Length@channel],#]]&@setting[dev],
		Switch[channel,All|_Integer,setting,{___Integer},
			OptionValue[ListExpander][channel,setting]]];
Options[UHDopenDefaultDevice]={Device:>(UHDfind[""][[1]]),
	ClockSource->"external",TxRate->16*^6,
	FPGAimage->"/home/john/usrp_b200mini_fpga_with_tx_gpio.bin"}
UHDopenDefaultDevice[OptionsPattern[]]:=Module[{
		fpgaImage=OptionValue[FPGAimage]},
	$UHDusrp=UHDopen[OptionValue[Device]<>If[StringQ[fpgaImage],
		",fpga="<>fpgaImage,""]];
	UHDsetClockSource[$UHDusrp,OptionValue[ClockSource]];
	UHDsetTxRate[$UHDusrp,OptionValue[TxRate]];
	$UHDusrp
];
Options[UHDinit]=Join[{Host->"aqs26",ConnectionPort->50022,
		ControllProgram->
			"DISPLAY=:0 /home/john/git/ODMRtools/UHDLink/Debug/UHDLink",
		LocalControlPorts->{50507,50508},RemoteControlPorts->{50507,50508}},
	Options[UHDopenDefaultDevice]];
UHDinit[o:OptionsPattern[]]:=
	({$UHDcontrollProcess,$UHDlink}=InstallLink[OptionValue[Host],
		OptionValue[ControllProgram],
		Sequence@@FilterRules[Join[{o},Options@UHDinit],Options@InstallLink]])//
	Append[#,UHDopenDefaultDevice[Sequence@@FilterRules[{o},
		Options@UHDopenDefaultDevice]]]&;
UHDdeinit[]:=(If[IntegerQ[$UHDusrp],UHDclose[$UHDusrp];$UHDusrp=.];
	If[MatchQ[$UHDlink,_LinkObject],LinkClose[$UHDlink];$UHDlink=.]);
UHDgetMainboardOfTxChannel[dev_Integer,channel_Integer?NonNegative]:=
	Module[{n=UHDgetNumMboards[dev],i=0,c=channel},
		While[i<n,If[c<#,Return[i],
				c-=#;i++]&@Length[UHDgetTxSubdevSpec[dev,i]]];
		$Failed["invalid tx channel",channel]];
Options[UHDgetAllTxChannels]={LabelWithMainboard->False};
UHDgetAllTxChannels[dev_Integer,mBoard:(_Integer|All):All,OptionsPattern[]]:=
	With[{n=UHDgetNumMboards[dev],label=OptionValue[LabelWithMainboard]===True},
		Reap[Fold[With[{mc=Length[UHDgetTxSubdevSpec[dev,#2]]},
					Sow[#2->Range[#1,#1+mc-1]];#1+mc]&,0,Range[0,n-1]]]//
		{#[[1]],If[Length[#]>0,#[[1]],{}]&@#[[2]]}&//
		If[mBoard===All,If[label,#2,Range[0,#1-1]],
			mBoard/.#2//If[ListQ[#],#,{}]&]&@@#&];
Options[UHDgetTxMasterChannel]={Channel->0};
UHDgetTxMasterChannel[dev_Integer,OptionsPattern[]]:=
	Module[{n=UHDgetNumMboards[dev],i=0,mc=0,c=OptionValue[Channel]},
		While[i<n,Function[l,If[c<mc+l,
					Return@If[Length[#]>0,#[[1]],c]&@
					Select[Range[mc,mc+l-1],
						StringMatchQ[UHDgetTxSubdevName[dev,#],___~~"TX1"]&],
				mc+=l;i++]]@Length[UHDgetTxSubdevSpec[dev,i]]];
		$Failed["invalid tx channel",channel]];
Options[UHDgetStreamedTxChannels]={TxStreamer:>$UHDtxStreamer};
UHDgetStreamedTxChannels[dev_Integer,OptionsPattern[]]:=	
	With[{streamers=Switch[#,{___Integer},#,_Integer,{#},_,{}]&@
				If[FunctionQ[#],#[dev],#]&@OptionValue[TxStreamer]},
		Join@@(Function[streamer,
				If[IntegerQ[streamer]&&UHDtxStreamerRunning[streamer],
					UHDgetTxStreamDeviceAndChannelsAndMaxBufferSize[streamer][[2]],{}]]/@
			streamers)];
Options[UHDgetStaticallyEnabledTxChannels]=Join[
	{ChannelsToCheck->All,CheckFrondEndReadBack->False,
		IgnoreStreamedChannels->False},Options@UHDgetStreamedTxChannels];
UHDgetStaticallyEnabledTxChannels[dev_Integer,o:OptionsPattern[]]:=
	With[{channelsToCheck=Switch[#,{___Integer},#,_Integer,{#},
				All|"Any",UHDgetAllTxChannels[dev],_,{}]&@OptionValue[ChannelsToCheck],
			checkFrontEndReadback=OptionValue[CheckFrondEndReadBack]===True},
		Complement[channelsToCheck,If[OptionValue[IgnoreStreamedChannels]=!=False,
				UHDgetStreamedTxChannels[dev,
					Sequence@@FilterRules[{o},Options@UHDgetStreamedTxChannels]],{}]]//
		Select[#,Function[channel,
				Norm[BitShiftRight[#,4]&/@UHDgetTxIdle[dev,channel]]>0&&
					If[checkFrontEndReadback,
						BitAnd[UHDgetGPIOattr[dev,"FE"<>ToString[channel],"READBACK"],
							16^^A0]==16^^A0,True]]]&];
Options[UHDgetEnabledTxChannels]=Join[Options@UHDgetStaticallyEnabledTxChannels,
		UHDgetStaticallyEnabledTxChannels]
UHDgetEnabledTxChannels[dev_Integer,o:OptionsPattern[]]:=
	Join[UHDgetStreamedTxChannels[dev,
			Sequence@@FilterRules[{o},Options@UHDgetStreamedTxChannels]],
		UHDgetStaticallyEnabledTxChannels[dev,IgnoreStreamedChannels->True,
			Sequence@@FilterRules[{o},Options@UHDgetStaticallyEnabledTxChannels]]];
Options[UHDcheckMIMOstate]=Join[{ChannelsToCheck->All},
	Options@UHDgetEnabledTxChannels];
UHDcheckMIMOstate[dev_Integer,o:OptionsPattern[]]:=
	With[{channelsToCheck=Switch[#,{___Integer},#,_Integer,{#},
				All,UHDgetEnabledTxChannels[dev,
					Sequence@@FilterRules[{o},Options@UHDgetEnabledTxChannels]],
				_,{}]&@OptionValue[ChannelsToCheck]},
	Function[{mBoard,mChannels},
				UHDsetMIMO[dev,mBoard,Length@Intersection[channelsToCheck,mChannels]>1]
			]@@#&/@UHDgetAllTxChannels[dev,LabelWithMainboard->True]];
Options[UHDstaticTxEnabledQ]=Join[{Channel:>$UHDdefaultTxChannel},
		Options@UHDgetStaticallyEnabledTxChannels];
UHDstaticTxEnabledQ[dev_Integer,o:OptionsPattern[]]:=
	With[{channels=Switch[#,{___Integer},#,_Integer,{#},
				All|"Any",UHDgetAllTxChannels[dev],_,{}]&@
				If[FunctionQ[#],#[dev],#]&@OptionValue[Channel]},
		UHDgetStaticallyEnabledTxChannels[dev,ChannelsToCheck->channels,
			Sequence@@FilterRules[{o},Options@UHDgetStaticallyEnabledTxChannels]]//
		Switch[OptionValue[Channel],
			_Integer|{___Integer}|All,Length[#]===Length[channels],
			"Any",Length[#]>0,_,False]&];
Options[UHDenableStaticTx]=Join[
	{Amplitude:>$UHDtxAmplitude,Phase:>$UHDtxPhase,RawInput->False,
		Channel->0,BitsToSpare->4},
	Options@UHDgetStreamedTxChannels];
UHDenableStaticTx::channelAlreadyStreamed=
	"Channel `1` is already streamed to,ignoring";
UHDenableStaticTx[dev_Integer,o:OptionsPattern[]]:=
	With[{channels=Switch[#,_List,#,All,UHDgetAllTxChannels[dev],_Integer,{#},
					"Any",$UHDdefaultTxChannel[dev],_,{}]&@OptionValue[Channel],
			bitsToSpare=OptionValue[BitsToSpare],
			streamedChannels=UHDgetStreamedTxChannels[dev,
				Sequence@@FilterRules[{o},Options@UHDgetStreamedTxChannels]]},
		Function[{channel,x,phi},
			If[MemberQ[streamedChannels,channel],
				Message[UHDenableStaticTx::channelAlreadyStreamed,channel],
				With[{fe="FE"<>ToString[channel],
						rot=Function[{{Cos[phi],-Sin[phi]},{Sin[phi],Cos[phi]}}.#],
						mask=2^(16-bitsToSpare)-1,
						maxValue=2^(15-bitsToSpare)-1},
					UHDsetGPIOattr[dev,fe,"MANUAL",1,1];
					UHDsetGPIOattr[dev,fe,"CTRL",16^^00,16^^FF];
					UHDsetGPIOattr[dev,fe,"OUT",16^^E1,16^^FF];
					UHDsetTxIdle[dev,channel,
						If[OptionValue[RawInput]===True,
							If[phi=!=0,
								BitOr[BitShiftLeft[#,bitsToSpare]&@BitAnd[#,mask]&@
									Round@
									rot[If[#>maxValue,#-2*(maxValue+1),#]&/@
										BitShiftRight[x,bitsToSpare],
									 	BitAnd[x,2^bitsToSpare-1]]],
								x],
							BitShiftLeft[BitAnd[
									Clip[Round[#*maxValue],{-maxValue-1,maxValue}],
									mask],
								bitsToSpare]&@If[phi=!=0,rot[x],x]]];
			]]]@@#&/@
		Transpose[{channels,Function[amplitude,
					Switch[amplitude,	_?NumericQ,{amplitude,0}&/@channels,
						{_?NumericQ,_?NumericQ},amplitude&/@channels,
						{{_?NumericQ,_?NumericQ}...},
						PadRight[amplitude,Length[channels],amplitude]]]@
				UHDgetChannelSpecificSetting[dev,channels,OptionValue[Amplitude],
					ListExpander->(#&)],
				UHDgetChannelSpecificSetting[dev,channels,OptionValue[Phase]]}];
		UHDcheckMIMOstate[dev,ChannelsToCheck->Union[channels,streamedChannels]];];
Options[UHDdisableStaticTx]={Channel->All};
UHDdisableStaticTx[dev_Integer,OptionsPattern[]]:=
	With[{channels=Switch[#,_List,#,All,UHDgetAllTxChannels[dev],_Integer,{#},
					"Any",$UHDdefaultTxChannel[dev],_,{}]&@ptionValue[Channel]},
		Function[channel,
			With[{fe="FE"<>ToString[channel]},
				UHDsetTxIdle[dev,channel,{0,0}];
				UHDsetGPIOattr[dev,fe,"OUT",16^^00,16^^FF];
				UHDsetGPIOattr[dev,fe,"CTRL",16^^FF,16^^FF];
				UHDsetGPIOattr[dev,fe,"MANUAL",0,1]]]/@channels;
			UHDcheckMIMOstate[dev];];
Options[UHDgenerateIQoffsetFrequencyWaveform]=
	{FrequencyOffset->0,Phase->0,Amplitude->1,
		SampleBits->16,CoerceFrequencies->True,PackInTxStreamerBuffer->False};
UHDgenerateIQoffsetFrequencyWaveform[numChannels_Integer?NonNegative,
		sampleRate_?NumericQ,bufferLength_Integer?Positive,OptionsPattern[]]:=
	With[{bits=OptionValue[SampleBits],
			padFunction=Function[x,If[Head[x]===List,PadRight[x,numChannels,x],
						ConstantArray[x,numChannels]]],
			coerceFrequencies=OptionValue[CoerceFrequencies]},
		Module[{frequencyOffsets=padFunction@OptionValue[FrequencyOffset],
				phases=padFunction@OptionValue[Phase],
				amplitudes=padFunction@OptionValue[Amplitude]},
			UHDdebugPrint[{frequencyOffsets,phases,amplitudes}];
			Function[{df,phi,amp},
				Clip[Round[#*(2^(bits-1)-1)],{-2^(bits-1)+1,2^(bits-1)-1}]&/@
				Flatten@Array[Function[t,
						amp*{Cos[2*Pi*df*t+phi],Sin[2*Pi*df*t+phi]}][(#-1)/sampleRate]&,
					bufferLength]]@@#&/@
			Transpose[{If[coerceFrequencies,
						Round[#,sampleRate/bufferLength],#]&/@frequencyOffsets,
					phases,amplitudes}]//
			If[OptionValue[PackInTxStreamerBuffer]===True,
					UHDcreateTxStreamerBuffer[#],UHDcreateIQbuffer/@#]&]];
Options[UHDgenerateAndQueueMinimalIQoffsetFrequencyWaveform]=Join[
	{FrequencyOffset:>$UHDtxFrequencyOffset,Phase:>$UHDtxPhase,
		Amplitude:>$UHDtxAmplitude,TxStreamer:>$UHDtxStreamer,
		BufferLength->Function[{maxBufferLengh,sampleRate},maxBufferLengh],
		DisposeTxBufferAfterUse->True},
	Options@UHDgenerateIQoffsetFrequencyWaveform];
UHDgenerateAndQueueMinimalIQoffsetFrequencyWaveform[dev_Integer,
		o:OptionsPattern[]]:=
	With[{streamer=If[FunctionQ[#1],#1[dev],#1]&@OptionValue[TxStreamer],
			padFunction=Function[{x,l},
					If[Head[x]===List,PadRight[x,Length[l],x],(x&)/@l]]},
		If[IntegerQ[streamer]&&UHDtxStreamerRunning[streamer],
			UHDgetTxStreamDeviceAndChannelsAndMaxBufferSize[streamer]//
			If[MatchQ[#1,{dev,{___Integer},_Integer}],
				Function[{streamerDev,channels,maxBufferLengh},
					Module[{frequencyOffsets=UHDgetChannelSpecificSetting[dev,channels,
									OptionValue[FrequencyOffset]],
							phases=UHDgetChannelSpecificSetting[dev,channels,
									OptionValue[Phase]],
							amplitudes=UHDgetChannelSpecificSetting[dev,channels,
									OptionValue[Amplitude]],
							sampleRates=(UHDgetTxRate[dev,#1]&)/@channels},
						UHDdebugPrint[{frequencyOffsets,phases}];
						If[Min[sampleRates]==Max[sampleRates],
							UHDgenerateIQoffsetFrequencyWaveform[Length@channels,
								sampleRates[[1]],
								If[Head[#1]===Function,#1[maxBufferLengh,sampleRates[[1]]],#1]&@
								OptionValue[BufferLength],
								FrequencyOffset->frequencyOffsets,Phase->phases,
								Amplitude->amplitudes,PackInTxStreamerBuffer->True,
								Sequence@@FilterRules[{o},
									Options@UHDgenerateIQoffsetFrequencyWaveform]]//
							(If[OptionValue[DisposeTxBufferAfterUse]===True,
								UHDsetTxStreamerBufferFreeAfterUse[#,True]];#)&//
							(UHDqueueTxStreamerBuffer[streamer,#];#)&,
							$Failed["sampleRates do not match"]]]]@@#,
				$Failed["communication problem",#]]&,
			$Failed["invalid tx streamer",streamer]]];
Options[UHDstartDefaultStreamer]={Channel->0,Timeout->0.1,Arguments->""};
UHDstartDefaultStreamer::adjustSampleRate=
	"increasing sampleRate of channel `1` from `2` to `3`";
UHDstartDefaultStreamer[dev_Integer,OptionsPattern[]]:=
	With[{channels=Switch[#,All,UHDgetAllTxChannels[dev],
					"Any",{0},_List,#,_Integer,{#},_,{}]&@OptionValue[Channel],
			timeout=OptionValue[Timeout],args=OptionValue[Arguments],
			streamer=$UHDtxStreamer[dev]},
		If[MatchQ[channels,{__Integer}],
			UHDdisableStaticTx[dev,Channel->channels];
			If[!IntegerQ[streamer]||!UHDtxStreamerRunning[streamer]||
					With[{runningChannels=
									UHDgetTxStreamDeviceAndChannelsAndMaxBufferSize[streamer][[2]]
							},UHDdebugPrint[{channels,runningChannels}];
							If[Length[channels]!=Length[runningChannels]||
									channels!=runningChannels,
								UHDdebugPrint[
									"stopping current streamer because of channel layout"];
								UHDstopTxStreamer[streamer];
								True,
								False
							]],
				With[{sampleRates=UHDgetTxRate[dev,#]&/@channels},
					With[{maxSampleRate=Max[sampleRates]},
						Function[{channel,sampleRate},
							If[sampleRate<maxSampleRate,
								Message[UHDstartDefaultStreamer::adjustSampleRate,channel,
									sampleRate,maxSampleRate];
								UHDsetTxRate[dev,channel,maxSampleRate]]]@@#&/@
						Transpose[{channels,sampleRates}]
					]];
				$UHDtxStreamer[dev]=(UHDdebugPrint[#];#)&@
					UHDstartTxStreamer[dev,timeout,args,"sc16","sc16",channels,True];
				Pause[timeout];
			];
		];
		$UHDtxStreamer[dev]];
UHDstopDefaultStreamer[dev_Integer]:=
	If[IntegerQ[$UHDtxStreamer[dev]],
		UHDstopTxStreamer[$UHDtxStreamer[dev]];
		$UHDtxStreamer[dev]=.;];
Options[UHDenableTx]=Join[{Channel->0,
	UseStaticTxForZeroFrequencyOffset:>$UHDuseStaticTxForZeroFrequencyOffset},
	Options@UHDgetStreamedTxChannels,Options@UHDgetStaticallyEnabledTxChannels,
	Options@UHDstartDefaultStreamer,Options@UHDenableStaticTx,
	Options@UHDgenerateAndQueueMinimalIQoffsetFrequencyWaveform];
UHDenableTx::txBufferFreeAfterUseSet=
	"tx buffer `1` still marked for freeAfterUse,ignoring channels `2`";
UHDenableTx::invalidTxBuffer="invalid tx buffer: `1`";
UHDenableTx[dev_Integer,o:OptionsPattern[]]:=
	With[{streamAllChannels=(If[FunctionQ[#],#[dev],#]&@
					OptionValue[UseStaticTxForZeroFrequencyOffset])===False,
			streamer=If[FunctionQ[#1],#1[dev],#1]&@OptionValue[TxStreamer],
			channels=Switch[#,{___Integer},#,_Integer,{#},
					All,UHDgetAllTxChannels[dev],"Any",$UHDdefaultTxChannel[dev],_,{}]&@
				OptionValue[Channel],
			getChannelSpecificOptions=Function[{option,channels},
				If[FunctionQ[#],If[ListQ[#],#[[channels]],#]&@#[dev],
					PadRight[#,Length[channels],#]&@If[ListQ[#],#,{#}]]&@
				OptionValue[option]]},
		With[{frequencyOffsets=UHDgetChannelSpecificSetting[dev,channels,
					OptionValue[FrequencyOffset]],
				phases=UHDgetChannelSpecificSetting[dev,channels,
					OptionValue[Phase]]},
			With[{channelsToStream=If[streamAllChannels,channels,
						Pick[channels,frequencyOffsets,Except[0|0.]]],
					channelsToStaticallyEnable=If[streamAllChannels,{},
						Pick[channels,frequencyOffsets,0|0.]],
					streamedChannels=UHDgetStreamedTxChannels[dev,
						Sequence@@FilterRules[{o},Options@UHDgetStreamedTxChannels]],
					staticallyEnabledChannels=UHDgetStaticallyEnabledTxChannels[dev,
						Sequence@@FilterRules[{o},
							Options@UHDgetStaticallyEnabledTxChannels]],
					amplitudes=If[ListQ[#],PadRight[#,Length[channels],#],
							Function[c,#]/@channels]&@
						If[FunctionQ[#],#[dev],#]&@OptionValue[Amplitude]},
				UHDdebugPrint[{streamAllChannels,streamer,channels,frequencyOffsets,
					channelsToStream,channelsToStaticallyEnable,
					streamedChannels,staticallyEnabledChannels}];
				If[Length[channelsToStream]>0,
					Function[streamedChannelsToPreserve,
						If[Length[streamedChannelsToPreserve]>0,
							UHDdebugPrint[streamedChannelsToPreserve];
							Switch[UHDdebugPrint[#];#,Null,{},
								UHDtxBuffer[_Integer,{___Integer},_Integer,True|False],
								Function[{address,iqBuffers,numSamples,freeAfterUse},
									If[freeAfterUse,
										Message[UHDenableTx::txBufferFreeAfterUseSet,#,
											streamedChannelsToPreserve];
										UHDstopDefaultStreamer[dev];{},
										UHDsetTxStreamerBuffer[address,False,0&/@iqBuffers];
										UHDdestroyTxStreamerBuffer[address];
										UHDdestroyIQbuffer/@Pick[iqBuffers,streamedChannels,
												Alternatives@@channelsToStream];
										UHDiqBuffer[#,numSamples]&/@Pick[iqBuffers,streamedChannels,
												Alternatives@@streamedChannelsToPreserve]]]@@#,
								_,Message[UHDenableTx::invalidTxBuffer,#];
									UHDstopDefaultStreamer[dev];{}]&@
							UHDgetTxStreamerQueueTopAndClearQueue[streamer],{}]//
						If[Length[#]>0,UHDdebugPrint[#];
							With[{appendedChannels=Join[Cases[streamedChannels,Alternatives@@
											Join[streamedChannelsToPreserve,channelsToStream]],
										Cases[channelsToStream,Alternatives@@
											Complement[channelsToStream,streamedChannels]]]},
								UHDstartDefaultStreamer[dev,Channel->appendedChannels,
									Sequence@@FilterRules[{o},Options@UHDstartDefaultStreamer]];
								Join[#,
									UHDgenerateIQoffsetFrequencyWaveform[Length[channelsToStream],
										UHDgetTxRate[dev,channelsToStream[[1]]],#[[1,2]],
										FrequencyOffset->frequencyOffsets,Phase->phases,
										PackInTxStreamerBuffer->False,
										Sequence@@FilterRules[{o},
											Options@UHDgenerateMinimalIQoffsetFrequencyWaveform]]]//
								Permute[#,FindPermutation[
										Join[streamedChannelsToPreserve,channelsToStream],
										appendedChannels]]&//
								UHDqueueTxStreamerBuffer[$UHDtxStreamer[dev],#]&],
							UHDstartDefaultStreamer[dev,Channel->channelsToStream,
								Sequence@@FilterRules[{o},Options@UHDstartDefaultStreamer]];
							UHDgenerateAndQueueMinimalIQoffsetFrequencyWaveform[dev,
								TxStreamer->$UHDtxStreamer[dev],
								Sequence@@FilterRules[{o},Options@
									UHDgenerateAndQueueMinimalIQoffsetFrequencyWaveform]]]&	
					]@Complement[streamedChannels,channelsToStream]];
				UHDenableStaticTx[dev,Amplitude->Pick[amplitudes,channels,
						Alternatives@@channelsToStaticallyEnable],
					Channel->channelsToStaticallyEnable,
					Sequence@@FilterRules[{o},Options@UHDenableStaticTx]]];]];
Options[UHDdisableTx]=Join[{TxStreamer->$UHDtxStreamer,Channel->All},
	Options@UHDgetStreamedTxChannels,Options@UHDgetStaticallyEnabledTxChannels];
UHDdisableTx[dev_Integer,o:OptionsPattern[]]:=
	With[{streamer=If[FunctionQ[#1],#1[dev],#1]&@OptionValue[TxStreamer],
			channelsToDisable=Switch[#,{___Integer},#,_Integer,{#},
					All,UHDgetAllTxChannels[dev],"Any",$UHDdefaultTxChannel[dev],_,{}]&@
				OptionValue[Channel]},
		With[{streamedChannels=UHDgetStreamedTxChannels[dev,
					Sequence@@FilterRules[{o},Options@UHDgetStreamedTxChannels]],
				staticallyEnabledChannels=UHDgetStaticallyEnabledTxChannels[dev,
					Sequence@@FilterRules[{o},
						Options@UHDgetStaticallyEnabledTxChannels]]},
			If[Length[Intersection[channelsToDisable,streamedChannels]]>0,
				Function[streamedChannelsToPreserve,
					If[Length[streamedChannelsToPreserve]>0,
						UHDdebugPrint[streamedChannelsToPreserve];
						Switch[UHDdebugPrint[#];#,Null,{},
							UHDtxBuffer[_Integer,{___Integer},_Integer,True|False],
							Function[{address,iqBuffers,numSamples,freeAfterUse},
								If[freeAfterUse,
									Message[UHDenableTx::txBufferFreeAfterUseSet,#,
										streamedChannelsToPreserve];
									UHDstopDefaultStreamer[dev];{},
									UHDsetTxStreamerBuffer[address,False,0&/@iqBuffers];
									UHDdestroyTxStreamerBuffer[address];
									UHDdestroyIQbuffer/@Pick[iqBuffers,streamedChannels,
											Alternatives@@channelsToDisable];
									UHDiqBuffer[#,numSamples]&/@Pick[iqBuffers,streamedChannels,
											Alternatives@@streamedChannelsToPreserve]]
							]@@#,
							_,Message[UHDenableTx::invalidTxBuffer,#];
								UHDstopDefaultStreamer[dev];{}]&@
						UHDgetTxStreamerQueueTopAndClearQueue[streamer],{}]//
					(UHDstopDefaultStreamer[dev];#)&//
					If[Length[#]>0,UHDdebugPrint[#];
						UHDstartDefaultStreamer[dev,Channel->streamedChannelsToPreserve,
							Sequence@@FilterRules[{o},Options@UHDstartDefaultStreamer]];
						UHDqueueTxStreamerBuffer[$UHDtxStreamer[dev],#]]&	
				]@Complement[streamedChannels,channelsToDisable]];
			UHDdisableStaticTx[dev,
				Channel->Intersection[staticallyEnabledChannels,channelsToDisable]]]];
Options[UHDtxEnabledQ]=Join[{Channel->"Any"},
	Options@UHDgetStaticallyEnabledTxChannels,Options@UHDgetStreamedTxChannels];
UHDtxEnabledQ[dev_Integer,o:OptionsPattern[]]:=
	With[{streamer=If[FunctionQ[#],#[dev],#]&@OptionValue[TxStreamer],
			channel=OptionValue[Channel],
			enabledChannels=Union[UHDgetStreamedTxChannels[dev,
					Sequence@@FilterRules[{o},Options@UHDgetStreamedTxChannels]],
				UHDgetStaticallyEnabledTxChannels[dev,
					Sequence@@FilterRules[{o},
						Options@UHDgetStaticallyEnabledTxChannels]]]},
		Switch[channel,"Any",Length[enabledChannels]>0,
				All,Length[enabledChannels]==Length@UHDgetAllTxChannels[dev],
				{___Integer},Length[Intersection[channel,enabledChannels]]==
					Length[channel],
				_Integer,MemberQ[enabledChannels,channel],_,False]];
SCPIcmd::invalidSIprefix="`1` is not a valid SI prefix,treating as 1";
SCPIcmd::invalidChannel="`1` is not a valid channel,ignoring command";
SCPIcmd::invalidListLength="list has invalid length,ignoring command";
SCPIcmd::invalidList="`1` is not a valid list,ignoring command";
SCPIcmd::noListSelected="no list selected,ignoring command";
SCPIcmd::sweepNotSupported="sweep mode not supported,use list instead";
SCPIcmd::listModeTriggerNotSupported=
	"list trigger mode \"`1`\" is not supported,ignoring command";
SCPIcmd::listModeRunning="list mode already running on channel `1`";
SCPIcmd::unknownCmd="unknown command: `1`";
SCPIcmd[UHDDevice[dev_Integer],cmd_String,
	bufferSize:(_Integer?NonNegative|\[Infinity]):0,o:OptionsPattern[]]:=
With[{parseSCPIpattern=Function[
			Module[{collapseTop=Function[
						If[Length[#]>1,ReplacePart[Most[#],
								-1->If[Head[#[[-2]]]===Alternatives,
									Join[#[[-2]],#[[-1]]|""],#[[-2]]~~#[[-1]]|""]],#]],
					lCaseTopQ=Function[
						(StringQ[#]&&LowerCaseQ[#]&&StringLength[#]>0)&@#1[[-1]]],
					pattern=#1,
					parameterVarPatterns=If[SymbolQ[#],Pattern[#,NumberString],#]&/@
						If[Length[{##}]>1,{##}[[2]],{}]},
				Module[{lCaseCollapse=Function[If[lCaseTopQ[#1],collapseTop[#],#]]},
					First@lCaseCollapse@Fold[Switch[#2,
							"[",Append[lCaseCollapse[#1],""],
							"]",collapseTop@If[lCaseTopQ[#1]&&Length[#1]>0,
								ReplacePart[Most[#],
									-1->If[Head[#[[-2]]]===Alternatives,
										MapAt[Function[st,st~~#[[-1]]|""],#[[-2]],-1],
										#[[-2]]~~#[[-1]]|""]],#1],
							_?DigitQ,MapAt[Function[cp,cp~~
										With[{i=If[#2=="0",10,ToExpression[#2]]},
											If[1<=i<=Length[parameterVarPatterns],
												parameterVarPatterns[[i]],NumberString]|""]],
								#1,If[Head[#1[[-1]]]===Alternatives,{-1,-1},-1]
							]&[lCaseCollapse[#1],#2],
							_?LowerCaseQ,If[lCaseTopQ[#1],
								MapAt[Function[st,st~~#2],#1,-1],
								Append[#1,#2]],
							_,MapAt[Function[cp,cp~~#2],#1,
								If[Head[#1[[-1]]]===Alternatives,{-1,-1},-1]
							]&[lCaseCollapse[#1],#2]]&,
						{""},Characters[pattern]]]]],
		numChannels=Length@UHDgetAllTxChannels[dev],
		StringCaseCases=Function[StringCases[##,IgnoreCase->True]],
		CNumberString=RegularExpression["(\\+|-)?[0-9]+(\\.[0-9]*)?(e[0-9]+)?"],
		OnOffString="0"|"1"|"on"|"off",
		SIprefix="y"|"z"|"a"|"f"|"p"|"n"|"u"|"m"|"c"|"d"|""|"da"|"h"|"k"|"M"|"G"|
				"T"|"P"|"E"|"Z"|"Y",
		ListNamePattern=(LetterCharacter~~WordCharacter...)|
			("\""~~LetterCharacter~~WordCharacter...~~"\"")|
			("'"~~LetterCharacter~~WordCharacter...~~"'"),
		parseListName=Function[If[Length[#]>0,#[[1]]]&@StringCases[StringTrim[#],
			{"'"~~y:(LetterCharacter~~WordCharacter...)~~"'":>y,
				"\""~~y:(LetterCharacter~~WordCharacter...)~~"\"":>y,
				y:(LetterCharacter~~WordCharacter...):>y}]],
		OptionalWhitespace=(Whitespace|""),
		parseCString=Function[ToExpression[StringReplace[#,"e"|"E"->"*^"]]],
		parseSIprefix=Function[Switch[#,"y",-24,"z",-21,"a",-18,"f",-15,"p",-12,
				"n",-9,"u",-6,"m",-3,"c",-2,"d",-1,"",0,"da",1,"h",2,"k",3,"M",6,
				"G",9,"T",12,"P",15,"E",18,"Z",21,"Y",24,
				_,Message[SCPIcmd::invalidSIprefix,#];1]],
		makeChannelList=Function[channel,Switch[channel,
					All,UHDgetAllTxChannels[dev],{___Integer},channel,
					_Integer,{channel},_,{}]],
		repeatPatternWithComma=Function[pattern,
				pattern~~(Whitespace|""~~","~~Whitespace|""~~pattern)...],
		Z0=50},
	With[{ChannelPattern=NumberString?(0<=ToExpression[#]<numChannels&)|
					parseSCPIpattern["All"],
			ChannelListPattern=repeatPatternWithComma[
					NumberString?(0<=ToExpression[#]<numChannels&)]|
				parseSCPIpattern["All"],
			parseChannel=Function[StringSwitch[#,"",$UHDdefaultTxChannel[dev],
						parseSCPIpattern["All"],All,
						_,ToExpression[#],IgnoreCase->True]],			
			valueWithUnitPattern=Function[unit,
				CNumberString~~(OptionalWhitespace~~SIprefix~~unit)|""],
			parseValueWithUnit=Function[{value,unit},If[Length[#]>0,#[[1]]]&@
					StringCaseCases[StringTrim[value],
						y:CNumberString~~(OptionalWhitespace~~p:SIprefix~~unit)|"":>
							(parseCString[y]*10^parseSIprefix[p])]],
			PowerPattern=CNumberString~~(OptionalWhitespace~~SIprefix~~
						("B"~~SIprefix~~""|"V"|"W")|"V"|"W")|"",
			parsePower=Function[If[Length[#]>0,#[[1]]]&@StringCaseCases[
						StringTrim[#],
						y:CNumberString~~OptionalWhitespace~~p:SIprefix~~
								u:(("B"~~bp:SIprefix~~bu:""|"V"|"W")|"V"|"W"|""):>
							(StringSwitch[u,
								"B"~~___,30+#*10^(1+parseSIprefix[p])+
										10*StringSwitch[bu,"V",-Log[10,Z0]+2*parseSIprefix[bp],
											"W",parseSIprefix[bp],
											"",If[bp ==="",-3,parseSIprefix[bp]]],
								"",#,
								"V",30+20(Log[10,#]+parseSIprefix[p])-10*Log[10,Z0],
								"W",30+10(Log[10,#]+parseSIprefix[p])]&@parseCString[y])]],
			PhasePattern=
				CNumberString~~(OptionalWhitespace~~SIprefix~~"DEG"|"°"|"RAD")|"",
			parsePhase=Function[If[Length[#]>0,#[[1]]]&@StringCaseCases[StringTrim[#],
						y:CNumberString~~
								(OptionalWhitespace~~p:SIprefix~~u:"DEG"|"°"|"RAD")|"":>
							(parseCString[y]*10^parseSIprefix[p]*
								StringSwitch[u,"DEG"|"°",Degree,___,1,IgnoreCase->True])]],
			parseOnOffString=Function[If[Length[#]>0,#[[1]]]&@StringCaseCases[
						StringTrim[#],
						y:OnOffString:>StringSwitch[y,"0"|"off",False,"1"|"on",True,
								IgnoreCase->True]]],
			CommandString=Function[{namePattern},
				StartOfString~~parseSCPIpattern[namePattern]~~EndOfString],
			SetterString=Function[{namePattern,argPattern},
				StartOfString~~parseSCPIpattern[namePattern]~~
				Whitespace~~argPattern~~EndOfString],
			GetterString=Function[namePattern,
				StartOfString~~parseSCPIpattern[namePattern]~~"?"~~EndOfString],
			IndexedCommandString=Function[{namePattern,indexVarPatterns},
				StartOfString~~
					parseSCPIpattern[namePattern,indexVarPatterns]~~EndOfString],
			IndexedSetterString=Function[{namePattern,indexVarPatterns,argPattern},
				StartOfString~~parseSCPIpattern[namePattern,indexVarPatterns]~~
					Whitespace~~argPattern~~EndOfString],
			IndexedGetterString=Function[{namePattern,indexVarPatterns},
				StartOfString~~parseSCPIpattern[namePattern,indexVarPatterns]~~
					"?"~~EndOfString],
			getChannelSetting=Function[{setting,channel},
					If[channel=!=All&&ListQ[setting]&&Length[setting]==numChannels,
						setting[[1+channel]],setting]],
			setChannelSetting=Function[{setting,channel,value},
					If[channel===All,
						setting=value,
						If[!ListQ[setting]||Length[setting]!=numChannels||
								(ListQ[value]&&!ListQ[setting[[1]]]),
							setting=ConstantArray[setting,numChannels]];
						setting=ReplacePart[setting,
							If[ListQ[channel],
								If[ListQ[value]&&Length[value]==Length[channel],
									Rule@@#&/@Transpose[{1+channel,value}],
									1+#->value&/@channels],
								1+channel->value]]],{HoldFirst}]},
		Block[{c},
			StringSwitch[cmd,
				CommandString["*RST"],
				UHDdisableTx[dev,Channel->All];
				UHDresetStatusVariables[dev];
				Function[c,
					UHDsetTxFrequencyEx[dev,c,N@$UHDdefaultTxFrequency[dev],0.,"auto",0.,
						"manual"];
					UHDsetTxGain[dev,c,N[$UHDdefaultTxPower[dev]+
							getChannelSetting[$UHDtxPowerOffset[dev],c]]]
					]/@UHDgetAllTxChannels[dev],
				GetterString["*IDN"],
				StringJoin["UHDdevice: ",Riffle[{"{",Riffle[#,","],"}"}&/@#,","]]&[
					{"mBoard_id","mBoard_name","mBoard_serial"}/.UHDgetTxInfo[dev,#]&/@
					UHDgetAllTxChannels[dev]],
				CommandString["*WAI"],,
				CommandString[":ABORt:LIST"],
				If[ListQ[#],UHDdisableTxListMode/@Select[#,UHDtxListModeRunning];
					$UHDtxListModeThreads[dev]={};]&@$UHDtxListModeThreads[dev],
				SetterString["[:SOURce]:[DEFault]CHANnel",ChannelListPattern],
				Function[channel,$UHDdefaultTxChannel[dev]=
						Switch[channel,All,UHDgetAllTxChannels[dev],
							{_},channel[[1]],_,channel];]@
				StringCaseCases[cmd,
					Evaluate[SetterString["[:SOURce]:[DEFault]CHANnel",
							c:ChannelListPattern]]:>(parseChannel/@StringSplit[c,","])][[1]],
				GetterString["[:SOURce]:[DEFault]CHANnel"],
				StringJoin[Riffle[ToString[#,CForm]&/@#,","]]&@
				If[ListQ[#],#,{#}]&@$UHDdefaultTxChannel[dev],
				IndexedSetterString["[:SOURce1]:FREQuency[:CW|:FIXed]",{ChannelPattern},
					valueWithUnitPattern["Hz"]],
				Function[{channel,f},
					With[{ofm=If[$UHDtreatTxFrequencyWithOffset[dev]===1,1,0]},
						Function[c,UHDsetTxFrequencyEx[dev,c,
								N[f-ofm*getChannelSetting[$UHDtxFrequencyOffset[dev],c]],
								0.,"auto",0.,"manual"]]/@
						makeChannelList[channel];]]@@
				StringCaseCases[cmd,
					Evaluate[IndexedSetterString["[:SOURce1]:FREQuency[:CW|:FIXed]",
							{c:ChannelPattern},x:valueWithUnitPattern["Hz"]]]:>
						{parseChannel[c],parseValueWithUnit[x,"Hz"]}
				][[1]],
				IndexedGetterString["[:SOURce1]:FREQuency[:CW|:FIXed]",
					{ChannelPattern}],
				Function[channel,StringJoin[Riffle[ToString[#,CForm]&/@#,","]]&@
					With[{ofm=If[$UHDtreatTxFrequencyWithOffset[dev]===1,1,0]},
						Function[c,UHDgetTxFrequency[dev,c]+
							ofm*getChannelSetting[$UHDtxFrequencyOffset[dev],c]]/@
						makeChannelList[channel]]]@
				StringCaseCases[cmd,
					Evaluate[IndexedGetterString["[:SOURce1]:FREQuency[:CW|:FIXed]",
							{c:ChannelPattern}]]:>parseChannel[c]][[1]],
				IndexedSetterString["[:SOURce1]:FREQuency:MODE",{ChannelPattern},
						"CW"|parseSCPIpattern["FIXed"]|parseSCPIpattern["SWEep"]|"LIST"]|
					IndexedSetterString["[:SOURce1]:POWer:MODE",{ChannelPattern},
						parseSCPIpattern["FIXed"]|parseSCPIpattern["SWEep"]|"LIST"],
				Function[{channel,mode},
					StringSwitch[mode,
						"CW"|parseSCPIpattern["FIXed"],
							Function[{threads,channels},
								UHDdisableTxListMode/@
								(If[Length[#]>0,
									$UHDtxListModeThreads[dev]=
										Complement[$UHDtxListModeThreads[dev],#]];#)&@
								Select[threads,
									Length@Intersection[UHDgetTxListModeChannels[#],channels]>0&]
							][If[ListQ[#],Select[#,UHDtxListModeRunning],{}]&@
								$UHDtxListModeThreads[dev],makeChannelList[channel]],
						parseSCPIpattern["SWEep"],Message[SCPIcmd::sweepNotSupported];,
						"LIST",With[{channels=Union[#,
										UHDgetTxMasterChannel[dev,Channel->#]&/@#]&@
									makeChannelList[channel],
								blankerGPIOspec=If[
									MatchQ[#,{_Integer,_String,_Integer,_Integer}],
									#,{0,"FP0",1,1}]&@$UHDtxListModeBlankerGPIOspec[dev]},
						If[ListQ[$UHDtxListModeThreads[dev]],
							Union@@(UHDgetTxListModeChannels/@
								Select[$UHDtxListModeThreads[dev],UHDtxListModeRunning]),{}]//
						If[Length[Intersection[channels,#]]==0,
							UHDenableTxListMode[dev,N@$UHDtxListModeDwellTime[dev],
								$UHDtxListModeIncludeSettingInDwellTime[dev]===True,
								$UHDtxListModeStepQ[dev]===True,
								$UHDtxListModeTriggerSingle[dev]=!=False,
								N@$UHDtxListModeBlankerTime[dev],
								Sequence@@blankerGPIOspec,channels,
								If[Length[#]==numChannels,N@#[[1+channels]],{}]&@
								$UHDtxListModeFrequencyList[dev],
								If[Length[#]==numChannels,N@#[[1+channels]],{}]&@
								$UHDtxListModePowerList[dev],
								Switch[#,_String,#,
									_List?(Length[#]==numChannels&),#[[1+channels]],_,{}]&@
								$UHDtxListModePowerApmlifierNameList[dev]]//
							If[ListQ[$UHDtxListModeThreads[dev]],
								AppendTo[$UHDtxListModeThreads[dev],#],
								$UHDtxListModeThreads[dev]={#}]&,
							Message[SCPIcmd::listModeRunning,channel]]&],
						IgnoreCase->True];]@@
				Join[
					StringCaseCases[cmd,
						Evaluate[IndexedSetterString["[:SOURce1]:FREQuency:MODE",
								{c:ChannelPattern},
								x:"CW"|parseSCPIpattern["FIXed"]|parseSCPIpattern["SWEep"]|
										"LIST"]]:>
							{parseChannel[c],x}],
					StringCaseCases[cmd,
						Evaluate[IndexedSetterString["[:SOURce1]:POWer:MODE",
								{c:ChannelPattern},
								x:parseSCPIpattern["FIXed"]|parseSCPIpattern["SWEep"]|"LIST"]]:>
							{parseChannel[c],x}]
				][[1]],
				IndexedGetterString["[:SOURce1]:FREQuency:MODE",{ChannelPattern}]|
					IndexedGetterString["[:SOURce1]:POWer:MODE",{ChannelPattern}],
				Function[c,
					If[Switch[c,All,Length[#]==numChannels,
							{___Integer},Length@Intersection[#,c]==Length[c],
							_Integer,MemberQ[#,c]]&@
						If[ListQ[#],Union[UHDgetTxListModeChannels/@
								Select[#,UHDtxListModeRunning]],{}]&@
						$UHDtxListModeThreads[dev],
						"LIST","CW"]]@
				StringCaseCases[cmd,
					Evaluate[IndexedGetterString["[:SOURce1]:FREQuency:MODE",
							{c:ChannelPattern}]]:>parseChannel[c]][[1]],
				IndexedSetterString["[:SOURce1]:FREQuency:OFFSet",{ChannelPattern},
					valueWithUnitPattern["Hz"]],
				Function[{channel,newTxFrequencyOffset},
					If[newTxFrequencyOffset=!=getChannelSetting[
							$UHDtxFrequencyOffset[dev],channel],
						setChannelSetting[$UHDtxFrequencyOffset[dev],channel,
							newTxFrequencyOffset];
						If[UHDtxEnabledQ[dev,Channel->channel],
							UHDenableTx[dev,Channel->channel]]]]@@
				StringCaseCases[cmd,
					Evaluate[IndexedSetterString["[:SOURce1]:FREQuency:OFFSet",
							{c:ChannelPattern},x:valueWithUnitPattern["Hz"]]]:>
						{parseChannel[c],parseValueWithUnit[x,"Hz"]}][[1]],
				IndexedGetterString["[:SOURce1]:FREQuency:OFFSet",{ChannelPattern}],
				Function[channel,ToString[#,CForm]&@
					getChannelSetting[$UHDtxFrequencyOffset[dev],channel]]@
				StringCaseCases[cmd,
					Evaluate[IndexedGetterString["[:SOURce1]:FREQuency:OFFSet",
							{c:ChannelPattern}]]:>parseChannel[c]][[1]],
				IndexedSetterString["[:SOURce1]:POWer[:LEVel][:IMMEdiate][:AMPLitude]",
					{ChannelPattern},PowerPattern],
				Function[{channel,power},
					Function[c,
						With[{powerWanted=power+getChannelSetting[$UHDtxPowerOffset[dev],c],
								powerRange=UHDgetTxGainRange[dev]},
							If[$UHDscaleTxAmplitudeForFinePowerControl[dev],
								With[{powerToSet=If[Length[#]>0,
												#[[1,1]]+Ceiling[powerWanted-#[[1,1]],#[[1,3]]],
												powerWanted]&@
											Select[powerRange,#[[1]]<=powerWanted<=#[[2]]&]},
									UHDdebugPrint[{powerWanted,powerToSet}];
									UHDsetTxGain[dev,c,N[powerToSet]];
									With[{newAmlitude=10^((powerWanted-powerToSet)/20)},
										If[newAmlitude=!=getChannelSetting[$UHDtxAmplitude[dev],c],
											setChannelSetting[$UHDtxAmplitude[dev],c,newAmlitude];
											If[UHDtxEnabledQ[dev,Channel->c],
												UHDenableTx[dev,Channel->c]]]]],
								UHDsetTxGain[dev,c,N[powerWanted]]]]]/@
					makeChannelList[channel];]@@
				StringCaseCases[cmd,
					Evaluate[IndexedSetterString[
							"[:SOURce1]:POWer[:LEVel][:IMMEdiate][:AMPLitude]",
							{c:ChannelPattern},x:PowerPattern]]:>
						{parseChannel[c],parsePower[x]}][[1]],
				IndexedGetterString["[:SOURce1]:POWer[:LEVel][:IMMEdiate][:AMPLitude]",
					{ChannelPattern}],
				Function[channel,
					StringJoin[Riffle[ToString[#,CForm]&/@#,","]]&[
						Function[c,UHDgetTxGain[dev,c]-
							getChannelSetting[$UHDtxPowerOffset[dev],c]+
							If[$UHDscaleTxAmplitudeForFinePowerControl[dev],
								20*Log[10,Abs@getChannelSetting[$UHDtxAmplitude[dev],c]],0]]/@
						makeChannelList[channel]]]@
				StringCaseCases[cmd,
					Evaluate[IndexedGetterString[
							"[:SOURce1]:POWer[:LEVel][:IMMEdiate][:AMPLitude]",
							{c:ChannelPattern}]]:>parseChannel[c]][[1]],
				IndexedSetterString["[:SOURce1]:POWer[:LEVel][:IMMEdiate]:OFFSet",
					{ChannelPattern},PowerPattern],
				Function[{channel,newTxPowerOffset},
					Function[c,UHDsetTxGain[dev,c,
								UHDgetTxGain[dev,c]+newTxPowerOffset-
									getChannelSetting[$UHDtxPowerOffset[dev],c]]]/@
					makeChannelList[channel];
					setChannelSetting[$UHDtxPowerOffset[dev],channel,newTxPowerOffset];]@@
				StringCaseCases[cmd,
					Evaluate[IndexedSetterString[
							"[:SOURce1]:POWer[:LEVel][:IMMEdiate]:OFFSet",
							{c:ChannelPattern},x:PowerPattern]]:>
						{parseChannel[c],parsePower[x]}][[1]],
				IndexedGetterString["[:SOURce1]:POWer[:LEVel][:IMMEdiate]:OFFSet",
					{ChannelPattern}],
				Function[c,ToString[#,CForm]&@
					getChannelSetting[$UHDtxPowerOffset[dev],c]]@
				StringCaseCases[cmd,
					Evaluate[IndexedGetterString[
							"[:SOURce1]:POWer[:LEVel][:IMMEdiate]:OFFSet",
							{c:ChannelPattern}]]:>parseChannel[c]][[1]],
				IndexedSetterString["[:SOURce1]:OUTPut[:STATe]",{ChannelPattern},
					OnOffString],
				Function[{c,x},
					If[x,UHDenableTx[dev,Channel->c],UHDdisableTx[dev,Channel->c]]]@@
				StringCaseCases[cmd,
					Evaluate[
						IndexedSetterString["[:SOURce1]:OUTPut[:STATe]",{c:ChannelPattern},
							x:OnOffString]]:>
						{parseChannel[c],parseOnOffString[x]}][[1]],
				IndexedGetterString["[:SOURce1]:OUTPut[:STATe]",{ChannelPattern}],
				Function[channel,
					StringJoin[Riffle[ToString[#,CForm]&/@#,","]]&[
						Function[c,Boole@UHDtxEnabledQ[dev,Channel->c]]/@
						makeChannelList[channel]]]@
				StringCaseCases[cmd,
					Evaluate[IndexedGetterString["[:SOURce1]:OUTPut[:STATe]",
							{c:ChannelPattern}]]:>parseChannel[c]][[1]],
				IndexedSetterString["[:SOURce1]:PHASe",{ChannelPattern},PhasePattern],
				Function[{c,newPhase},
					If[newPhase=!=getChannelSetting[$UHDtxPhase[dev],c],
						setChannelSetting[$UHDtxPhase[dev],c,newPhase];
						If[UHDtxEnabledQ[dev,Channel->c],UHDenableTx[dev,Channel->c]]]]@@
				StringCaseCases[cmd,
					Evaluate[IndexedSetterString["[:SOURce1]:PHASe",{c:ChannelPattern},
							x:PhasePattern]]:>
						{parseChannel[c],parsePhase[x]}][[1]],
				IndexedGetterString["[:SOURce1]:PHASe",{ChannelPattern}],
				Function[c,If[ListQ[#],
						StringJoin[Riffle[ToString[#,CForm]&/@#,","]],ToString[#,CForm]]&@
					N@getChannelSetting[$UHDtxPhase[dev],c]]@
				StringCaseCases[cmd,
					Evaluate[IndexedGetterString["[:SOURce1]:PHASe",
							{c:ChannelPattern}]]:>parseChannel[c]][[1]],
				GetterString["[:SOURce]:LIST:CATalog"],
				StringJoin@Riffle[
					"'"<>#[[1]]<>"'"&/@If[ListQ[#],#,{}]&@$UHDtxListModeLists[dev],","],
				SetterString["[:SOURce]:LIST:DELete",ListNamePattern],
				($UHDtxListModeLists[dev]=DeleteCases[$UHDtxListModeLists[dev],#->_];)&@
				StringCaseCases[cmd,
					Evaluate[SetterString["[:SOURce]:LIST:DELete",x:ListNamePattern]]:>
						x][[1]],
				CommandString["[:SOURce]:LIST:DELete:ALL"],$UHDtxListModeLists[dev]={};,
				SetterString["[:SOURce]:LIST:DWELl",valueWithUnitPattern["s"]],
				($UHDtxListModeDwellTime[dev]=#;)&@
				StringCaseCases[cmd,
					Evaluate[SetterString["[:SOURce]:LIST:DWELl",
							x:valueWithUnitPattern["s"]]]:>
						parseValueWithUnit[x,"s"]][[1]],
				GetterString["[:SOURce]:LIST:DWELl"],
				ToString[$UHDtxListModeDwellTime[dev],CForm],
				GetterString["[:SOURce]:LIST:FREE"],"10000,0",
				CommandString["[:SOURce]:LIST:LEARn"],
				If[MatchQ[#,{_,_}],
					$UHDtxListModeFrequencyList[dev]=
						If[$UHDtxListModeSetOnlyFrequencyOfMasterChannel[dev],
							Flatten[
								ReplacePart[ConstantArray[{},Length[#]],
									1+First[Select[#[[1,2]]&/@#,
											StringMatchQ[UHDgetTxSubdevName[dev,#],___~~"TX1"]&]]->
										(If[Length[#]>0,#[[1]],{}]&@
											DeleteCases[Last/@#,{}])]&/@
								GatherBy[#,#[[1,1]]&]&@
								Transpose[{Flatten[Function[c,{#[[1]],c}]/@#[[2]]&/@
										UHDgetAllTxChannels[dev,LabelWithMainboard->True],1],#}],1]
						,#]&@#[[1]];
					$UHDtxListModePowerList[dev]=#[[2]]+$UHDtxPowerOffset[dev];,
					Message[SCPIcmd::invalidList,$UHDtxListModeSelectedList[dev]];
				]&[$UHDtxListModeSelectedList[dev]/.$UHDtxListModeLists[dev]],
				IndexedSetterString["[:SOURce1]:LIST:FREQuency",{ChannelPattern},
					repeatPatternWithComma[valueWithUnitPattern["Hz"]]],
				With[{list=$UHDtxListModeSelectedList[dev]},
					If[StringQ[list]&&StringLength[list]>0,
						Function[{channel,frequencies},
							Function[listData,
								If[listData===list||!MatchQ[listData,{{___},{___}}]||
										Length[listData[[1]]]!=numChannels,
									ConstantArray[{},numChannels],listData[[1]]]//
								Function[oldFrequencies,
									If[Length@DeleteCases[Union[Length/@oldFrequencies,
												{Length[frequencies]}],0]>1,
										Message[SCPIcmd::invalidListLength],
										Switch[channel,All,ConstantArray[frequencies,numChannels],
											{___Integer},ReplacePart[oldFrequencies,
												1+#->frequencies&/@channel],
											_Integer,ReplacePart[oldFrequencies,
												1+channel->frequencies]
										]//
										{#,If[listData===list,{},listData[[2]]]}&//
										If[listData===list,
											$UHDtxListModeLists[dev]=Append[$UHDtxListModeLists[dev],
													list->#],
											$UHDtxListModeLists[dev]=$UHDtxListModeLists[dev]/.
												{(list->_)->(list->#)}]&]];
							]@If[ListQ[#],list/.#,$UHDtxListModeLists[dev]={};list]&[
								$UHDtxListModeLists[dev]]]@@
						StringCaseCases[cmd,
							Evaluate[IndexedSetterString["[:SOURce1]:LIST:FREQuency",
									{c:ChannelPattern},
									x:repeatPatternWithComma[valueWithUnitPattern["Hz"]]]]:>
								{parseChannel[c],
									parseValueWithUnit[#,"Hz"]&/@StringSplit[x,","]}][[1]],
						Message[SCPIcmd::noListSelected]]],
				IndexedGetterString["[:SOURce1]:LIST:FREQuency:POINts",
					{ChannelPattern}],
				With[{list=$UHDtxListModeSelectedList[dev]},
					If[StringQ[list]&&StringLength[list]>0,
						Function[channel,
							If[#===list||!MatchQ[#,{{___},{___}}]||
									Length[#[[1]]]!=numChannels,0,
								Switch[channel,All,Max[Length/@#[[1]]],
									{___Integer},Max[Length/@#[[1,1+channel]]],
									_Integer,Length@#[[1,1+channel]]]]&@
							If[ListQ[#],list/.#,list]&[$UHDtxListModeLists[dev]]]@
						StringCaseCases[cmd,
							Evaluate[IndexedGetterString["[:SOURce1]:LIST:FREQuency:POINts",
									{c:ChannelPattern}]]:>parseChannel[c]][[1]],
						Message[SCPIcmd::noListSelected]]],
				IndexedSetterString["[:SOURce1]:LIST:POWer",{ChannelPattern},
					repeatPatternWithComma[PowerPattern]],
				With[{list=$UHDtxListModeSelectedList[dev]},
					If[StringQ[list]&&StringLength[list]>0,
						Function[{channel,powers},
							Function[listData,
								If[listData===list||!MatchQ[listData,{{___},{___}}]||
										Length[listData[[2]]]!=numChannels,
									ConstantArray[{},numChannels],listData[[2]]]//
								Function[oldPowers,
									If[Length@DeleteCases[Union[Length/@oldPowers,
												{Length[powers]}],0]>1,
										Message[SCPIcmd::invalidListLength],
										Switch[channel,All,ConstantArray[powers,numChannels],
											{___Integer},ReplacePart[oldPowers,
												1+#->powers&/@channel],
											_Integer,ReplacePart[oldPowers,
												1+channel->powers]
										]//
										{If[listData===list,{},listData[[1]]],#}&//
										If[listData===list,
											$UHDtxListModeLists[dev]=Append[$UHDtxListModeLists[dev],
													list->#],
											$UHDtxListModeLists[dev]=$UHDtxListModeLists[dev]/.
												{(list->_)->(list->#)}]&]];
							]@If[ListQ[#],list/.#,$UHDtxListModeLists[dev]={};list]&[
								$UHDtxListModeLists[dev]]]@@
						StringCaseCases[cmd,
							Evaluate[IndexedSetterString["[:SOURce1]:LIST:POWer",
									{c:ChannelPattern},
									x:repeatPatternWithComma[PowerPattern]]]:>
								{parseChannel[c],parsePower/@StringSplit[x,","]}][[1]],
						Message[SCPIcmd::noListSelected]]],
				IndexedGetterString["[:SOURce1]:LIST:POWer:POINts",
					{ChannelPattern}],
				With[{list=$UHDtxListModeSelectedList[dev]},
					If[StringQ[list]&&StringLength[list]>0,
						Function[channel,
							If[#===list||!MatchQ[#,{{___},{___}}]||
									Length[#[[2]]]!=numChannels,0,
								Switch[channel,All,Max[Length/@#[[2]]],
									{___Integer},Max[Length/@#[[2,1+channel]]],
									_Integer,Length@#[[2,1+channel]]]]&@
							If[ListQ[#],list/.#,list]&[$UHDtxListModeLists[dev]]]@
						StringCaseCases[cmd,
							Evaluate[IndexedGetterString["[:SOURce1]:LIST:POWer:POINts",
									{c:ChannelPattern}]]:>parseChannel[c]][[1]],
						Message[SCPIcmd::noListSelected]]],
				SetterString["[:SOURce]:LIST:MODE","AUTO"|"STEP"],
				($UHDtxListModeStepQ[dev]=StringMatchQ[#,"STEP",IgnoreCase->True];)&@
				StringCaseCases[cmd,
					Evaluate[SetterString["[:SOURce]:LIST:MODE",x:"AUTO"|"STEP"]]:>
						x][[1]],
				GetterString["[:SOURce]:LIST:MODE"],
				If[$UHDtxListModeStepQ[dev],"STEP","AUTO"],
				SetterString["[:SOURce]:LIST:SELect",ListNamePattern],
				($UHDtxListModeSelectedList[dev]=#;)&@
				StringCaseCases[cmd,
					Evaluate[SetterString["[:SOURce]:LIST:SELect",x:ListNamePattern]]:>
						parseListName[x]][[1]],
				GetterString["[:SOURce]:LIST:SELect"],$UHDtxListModeSelectedList[dev],
				IndexedCommandString[":TRIGger1:LIST[:IMMediate]",
					{NumberString|parseSCPIpattern["All"]}],
				Function[s,StringSwitch[s,
						parseSCPIpattern["All"],UHDtriggerTxListModeRun/@#,
						NumberString,Function[n,
							If[0<=n<Length[#],
								UHDtriggerTxListModeRun[#[[n+1]]]]]@ToExpression[s],
						"",If[Length[#]>0,UHDtriggerTxListModeRun[#[[-1]]]],
						IgnoreCase->True]&@
					If[ListQ[#],#,{}]&@$UHDtxListModeThreads[dev];]@
				StringCaseCases[cmd,
					Evaluate[IndexedCommandString[":TRIGger1:LIST[:IMMediate]",
							{c:NumberString|parseSCPIpattern["All"]}]]:>c][[1]],
				IndexedSetterString[":TRIGger1:LIST:SOURce",{NumberString},
					Alternatives@@(parseSCPIpattern/@{"AUTO","SINGle","EXTernal","HOP"})],
				Function[x,
					StringSwitch[x,
						"AUTO",$UHDtxListModeTriggerSingle[dev]=False,
						parseSCPIpattern["SINGle"],$UHDtxListModeTriggerSingle[dev]=True,
						parseSCPIpattern["EXTernal"],
						Message[SCPIcmd::listModeTriggerNotSupported,"EXTERNAL"],
						"HOP",Message[SCPIcmd::listModeTriggerNotSupported,"HOP"],
						IgnoreCase->True];]@
				StringCaseCases[cmd,
					Evaluate[IndexedSetterString[":TRIGger1:LIST:SOURce",{NumberString},
							x:Alternatives@@(parseSCPIpattern/@
								{"AUTO","SINGle","EXTernal","HOP"})]]:>x][[1]],
				IndexedGetterString[":TRIGger1:LIST:SOURce",{NumberString}],
				If[$UHDtxListModeTriggerSingle[dev]===False,"AUTO","SINGLE"],
				___,Message[SCPIcmd::unknownCmd,cmd],IgnoreCase->True]]]];
Options[UHDodmrCW]=Join[{CounterTriggerPolarity->1,TriggerOutPin->1,
		UsePLLlockAsTrigger->True},
	DeleteCases[Options[ODMRcw],
		(MicrowaveDevice|MicrowaveSettlingTime|MicrowaveDevice)->_]];
SetAttributes[UHDodmrCW,HoldFirst];
UHDodmrCW[pos_,dev_Integer,frequencies_,power_,o:OptionsPattern[]]:=
	With[{gpioMask=2^OptionValue[TriggerOutPin],
		triggerPolarity=OptionValue[CounterTriggerPolarity],
		fabOrOut=If[OptionValue[UsePLLlockAsTrigger]===True,"FABRIC","OUT"]},
	Module[{savedGPIOddr=BitAnd[UHDgetGPIOattr[dev,"FP0","DDR"],gpioMask],
			savedGPIOfabOrOut=BitAnd[UHDgetGPIOattr[dev,"FP0",fabOrOut],gpioMask],
			savedGPIOctrl=BitAnd[UHDgetGPIOattr[dev,"FP0","CTRL"],gpioMask],data},
		$UHDtxListModeIncludeSettingInDwellTime[dev]=False;
		$UHDtxListModeBlankerGPIOspec[dev]=
			If[fabOrOut==="OUT",{0,"FP0",gpioMask,If[triggerPolarity<0,gpioMask,0]},
				{0,"",0,0}];
		$UHDtxListModeBlankerTime[dev]=0;
		UHDsetGPIOattr[dev,"FP0","CTRL",0,gpioMask];
		UHDsetGPIOattr[dev,"FP0","DDR",gpioMask,gpioMask];
		UHDsetGPIOattr[dev,"FP0",fabOrOut,gpioMask,gpioMask];
		data=ODMRcw[pos,frequencies,power,
				MicrowaveDevice->UHDDevice[dev],UsePulseModulation->False,
				MicrowaveSettlingTime->0,CounterTriggerPolarity->triggerPolarity,
				Sequence@@FilterRules[{o},Options@ODMRcw]];
		UHDsetGPIOattr[dev,"FP0",fabOrOut,savedGPIOfabOrOut,gpioMask];
		UHDsetGPIOattr[dev,"FP0","DDR",savedGPIOddr,gpioMask];
		UHDsetGPIOattr[dev,"FP0","CTRL",savedGPIOctrl,gpioMask];
		data]];
